package com.unitesk.requality.eclipse.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.eclipse.editors.browser.ReqDocBrowser;
import com.unitesk.requality.eclipse.editors.browser.ReqMarker;

public class FindReplaceHandler extends AbstractHandler {

	public static String SearchString = null;

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		ReqDocBrowser reqBrowser = null;
		IWorkbenchPart part = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();
		if (!(part instanceof ReqMarker))
			return null;
		reqBrowser = ((ReqMarker) part).getBrowser();
		InputDialog dialog = new InputDialog(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), "Find", "Search string:", null, null);
		if (dialog.open() == Window.OK)
		{
			SearchString = dialog.getValue();
			if (SearchString == null || SearchString.isEmpty())
				return null;
			reqBrowser.findText(SearchString, false, false, false);
			reqBrowser.setFocus();
		}
		return null;
	}

}
