/*
 * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.unitesk.requality.eclipse.views.listeners;

import org.eclipse.jface.viewers.ITreeSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.DragSourceListener;

import com.unitesk.requality.nodetypes.Requirement;

public class TreeViewerDragSourceListener implements DragSourceListener {

    private TreeViewer tree;

    @SuppressWarnings("unused")
    private TreeViewerDragSourceListener() {
    }

    public TreeViewerDragSourceListener(TreeViewer tree) {
        this.tree = tree;
    }

    @Override
    public void dragStart(DragSourceEvent event) {
        ITreeSelection selected = (ITreeSelection) tree.getSelection();
        Object obj = selected.getFirstElement();
        if ((obj != null) && (obj instanceof Requirement)) {
            event.doit = true;

        } else {
            event.doit = false;
        }
    }

    @Override
    public void dragSetData(DragSourceEvent event) {
        // FIXME: 
//        if (ResourceTransfer.getInstance().isSupportedType(event.dataType)) {
//            ITreeSelection selected = (ITreeSelection) tree.getSelection();
//            Object obj = selected.getFirstElement();
//            if ((obj != null) && (obj instanceof Requirement)) {
//                Requirement req = (Requirement) obj;
//                TreeDBResourceIO db = (TreeDBResourceIO) req.getTreeDB();
//                event.data = db.getResourceByNode(req);
//            }
//        }
    }

    @Override
    public void dragFinished(DragSourceEvent event) {
    }

}
