package com.unitesk.requality.tests.merge;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

import com.unitesk.requality.documents.DocumentImporter;
import com.unitesk.requality.tools.Converter;

public class LegacyConverter {
    
    private final static String inputDirname = "/home/vnfedotov/tmp/lsb3/";
    private final static String outputDirname = "/tmp/lsb3Conv/";
    
    public static void main(String[] args) {
	File inputDir = new File(inputDirname);
	File outputDir = new File(outputDirname);
	if(!outputDir.exists())
	    outputDir.mkdir();
	File[] files = inputDir.listFiles();
	if(files.length!=0){
	    for(File html : files) {
		File xhtml = new File(outputDirname+html.getName()+".xhtml");
		convert(html, xhtml);
	    }
	}
    }
    
    protected LegacyConverter() {
	
    }
    
    public static void convert(File in, File out){
	try {
	    File tmp = new File("/tmp/"+out.getName());
	    Reader read = new FileReader(in);
	    Writer write = new FileWriter(tmp);
	    DocumentImporter.cleanHtml(read, write);
	    write.close();
	    read = new FileReader(tmp);
	    write = new FileWriter(out);
	    Converter conv = new Converter();
	    conv.convert(read, write);
	    write.close();
	    tmp.delete();
	    System.out.println("Converted "+in.getName());
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	} catch (IOException e) {
	    e.printStackTrace();
	}
    }
}
