package com.unitesk.requality.tests.merge;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import com.unitesk.requality.merge.Node;
import com.unitesk.requality.merge.Tree;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class Utils {

    public static Document parseXml(String filename) {
	try {
	    DocumentBuilderFactory factory = DocumentBuilderFactory
		    .newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    return builder.parse(filename);
	} catch (ParserConfigurationException e) {
	    e.printStackTrace();
	    return null;
	} catch (SAXException e) {
	    e.printStackTrace();
	    return null;
	} catch (IOException e) {
	    e.printStackTrace();
	    return null;
	}
    }

    public static Object invokePrivateMethod(Object target, String name,
	    Class<?>[] argTypes, Object[] argValues)
	    throws InvocationTargetException {
	try {
	    Method method = target.getClass().getDeclaredMethod(name, argTypes);
	    method.setAccessible(true);
	    return method.invoke(target, argValues);
	} catch (IllegalArgumentException e) {
	    e.printStackTrace();
	    return null;
	} catch (IllegalAccessException e) {
	    e.printStackTrace();
	    return null;
	} catch (SecurityException e) {
	    e.printStackTrace();
	    return null;
	} catch (NoSuchMethodException e) {
	    e.printStackTrace();
	    return null;
	}
    }

    public static boolean isParent(Node x, Node y) {
	if (x.isRoot() && !y.isRoot() || !x.isRoot() && !y.isRoot()) {
	    if (y.getParent().getDomNode().isSameNode(x.getDomNode()))
		return true;
	    else
		return false;
	} else
	    return false;
    }

    public static void writeXmlFile(Document doc, String filename) {
	try {
	    Source source = new DOMSource(doc);

	    File file = new File(filename);
	    Result result = new StreamResult(file);

	    Transformer xformer = TransformerFactory.newInstance()
		    .newTransformer();
	    xformer.transform(source, result);
	} catch (TransformerConfigurationException e) {
	} catch (TransformerException e) {
	}
    }

    public static List<Node> dumbDiff(Tree t1, Tree t2) {
	List<Node> result = new ArrayList<Node>();
	for (Node x : t1.getTraversalSequence()) {
	    boolean found = false;
	    for (Node y : t2.getTraversalSequence())
		if (x.isEqual(y)) {
		    found = true;
		    break;
		}
	    if (!found)
		result.add(x);
	}
	return result;
    }
}
